# coding: utf-8

"""
    Fatture in Cloud API v2 - API Reference

    Connect your software with Fatture in Cloud, the invoicing platform chosen by more than 500.000 businesses in Italy.   The Fatture in Cloud API is based on REST, and makes possible to interact with the user related data prior authorization via OAuth2 protocol.

    The version of the OpenAPI document: 2.0.30
    Contact: info@fattureincloud.it
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field

try:
    from typing import Self
except ImportError:
    from typing_extensions import Self


class ArchiveDocument(BaseModel):
    """
    ArchiveDocument
    """  # noqa: E501

    id: Optional[StrictInt] = Field(default=None, description="Archive document id")
    var_date: Optional[date] = Field(
        default=None, description="Archive document date", alias="date"
    )
    description: Optional[StrictStr] = Field(
        default=None, description="Archive Document description"
    )
    attachment_url: Optional[StrictStr] = Field(
        default=None,
        description="[Temporary] [Read Only] Archive Document url of the attached file",
    )
    category: Optional[StrictStr] = Field(
        default=None, description="Archive document category"
    )
    attachment_token: Optional[StrictStr] = Field(
        default=None,
        description="[Write Only]  [Required] Archive document attachment token returned by POST /archive/attachment",
    )
    __properties: ClassVar[List[str]] = [
        "id",
        "date",
        "description",
        "attachment_url",
        "category",
        "attachment_token",
    ]

    model_config = {"populate_by_name": True, "validate_assignment": True}

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ArchiveDocument from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
                "attachment_url",
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ArchiveDocument from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "id": obj.get("id"),
                "date": obj.get("date"),
                "description": obj.get("description"),
                "attachment_url": obj.get("attachment_url"),
                "category": obj.get("category"),
                "attachment_token": obj.get("attachment_token"),
            }
        )
        return _obj
