# coding: utf-8

"""
    Fatture in Cloud API v2 - API Reference

    Connect your software with Fatture in Cloud, the invoicing platform chosen by more than 500.000 businesses in Italy.   The Fatture in Cloud API is based on REST, and makes possible to interact with the user related data prior authorization via OAuth2 protocol.

    The version of the OpenAPI document: 2.0.30
    Contact: info@fattureincloud.it
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel
from fattureincloud_python_sdk.models.permission_level import PermissionLevel

try:
    from typing import Self
except ImportError:
    from typing_extensions import Self


class PermissionsFicIssuedDocumentsDetailed(BaseModel):
    """
    PermissionsFicIssuedDocumentsDetailed
    """  # noqa: E501

    quotes: Optional[PermissionLevel] = None
    proformas: Optional[PermissionLevel] = None
    invoices: Optional[PermissionLevel] = None
    receipts: Optional[PermissionLevel] = None
    delivery_notes: Optional[PermissionLevel] = None
    credit_notes: Optional[PermissionLevel] = None
    orders: Optional[PermissionLevel] = None
    work_reports: Optional[PermissionLevel] = None
    supplier_orders: Optional[PermissionLevel] = None
    self_invoices: Optional[PermissionLevel] = None
    __properties: ClassVar[List[str]] = [
        "quotes",
        "proformas",
        "invoices",
        "receipts",
        "delivery_notes",
        "credit_notes",
        "orders",
        "work_reports",
        "supplier_orders",
        "self_invoices",
    ]

    model_config = {"populate_by_name": True, "validate_assignment": True}

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PermissionsFicIssuedDocumentsDetailed from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={},
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of PermissionsFicIssuedDocumentsDetailed from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "quotes": obj.get("quotes"),
                "proformas": obj.get("proformas"),
                "invoices": obj.get("invoices"),
                "receipts": obj.get("receipts"),
                "delivery_notes": obj.get("delivery_notes"),
                "credit_notes": obj.get("credit_notes"),
                "orders": obj.get("orders"),
                "work_reports": obj.get("work_reports"),
                "supplier_orders": obj.get("supplier_orders"),
                "self_invoices": obj.get("self_invoices"),
            }
        )
        return _obj
